
/**
   A simple generic Sequence abstract data type.

   See pages 146 - 155 and 232 - 238 of the textbook.
   (The book's Seq is not a very well designed abstract data type.
    It mixes ideas from iterators with ideas from lists.)

   This Sequence ADT is kind of like lists in Python and JavaScript
   and it is similar to Java's Vector and C++'s Vector.
      https://docs.oracle.com/javase/8/docs/api/java/util/Vector.html
      http://www.cplusplus.com/reference/vector/vector/

   Here is what the Sequence interface adds to the Container interface.
      public void add(int i, T e);
      public void set(int i, T e);
      public    T get(int i);
      public    T remove(int i);
*/
public abstract class Sequence<T> extends Container<T>
{
   /**

   */
   protected Sequence()
   {
       super("[[", "]]");
   }

   /**

   */
   public abstract void add(int i, T e);

   /**

   */
   public abstract void set(int i, T e);


   /**

   */
   public abstract    T get(int i);


   /**

   */
   public abstract    T remove(int i);

}//Sequence
