
/**
   A simple generic Set abstract data type.

   See page 170, Programming Project 6 of the textbook,
   and Programming Assignment 2.
      http://math.purduecal.edu/~rlkraft/cs27500/homework/hw2.html

   Here is what the Set interface adds to the Container interface.
      public boolean remove(T element);
      public Set<T> union(Set<T> s);
      public Set<T> intersection(Set<T> s);
      public Set<T> minus(Set<T> s);
      public static <T> Set<T> emptySetFactory()
*/
public abstract class Set<T> extends Container<T>
{
   /**

   */
   protected Set()
   {
       super("{", "}");
   }


   /**

   */
   public abstract boolean remove(T element);


   /**

   */
   public Set<T> union(Set<T> s)
   {
      Set<T> newSet = emptySetFactory();

      for (T e : this)
         newSet.add(e);

      for (T e : s)
         newSet.add(e);

      return newSet;
   }


   /**

   */
   public Set<T> intersection(Set<T> s)
   {
      Set<T> newSet = emptySetFactory();

      for (T e : this)
         if( s.contains(e) )
            newSet.add(e);

      return newSet;
   }


   /**

   */
   public Set<T> minus(Set<T> s)
   {
      Set<T> newSet = emptySetFactory();

      for (T e : this)
         if( ! s.contains(e) )
            newSet.add(e);

      return newSet;
   }

   /**
      This is really not a good idea.
      This method should be an "abstract static"
      method, but Java does not allow that.
      http://stackoverflow.com/questions/370962/why-cant-static-methods-be-abstract-in-java
   */
   public static <T> Set<T> emptySetFactory() // is this type safe???
   {
      return null;
   }

}//Set
